///# Skiplist
///<p>skiplist is an important data structure of database and many database use this as the basic structure in memory.
/// In the database I also use two Skiplist in memory to store datas temperary.</p>

use crate::algorithm;
pub mod skip_lists
{
    use std::{cell::RefCell, rc::Rc};

    use crate::algorithm::random;

    #[derive(Debug,Clone)]
    ///## Node of skiplist
    ///
    /// <p>We will build a kv database,so the node has two members key and value.</p>
    ///
    /// <p>The node would never be used out of the mod.</p>
    struct Node<K,V>                              
    {
        key:K,
        value:V,
        level:usize,
        forward:Vec<Option<Rc<RefCell<Node<K,V>>>>>
    }
    impl<K,V> Node<K,V>{
        fn new(_key:K,_value:V,_level:usize)->Rc<RefCell<Self>>
        {
            Rc::new(
                RefCell::new(
                    Node
                    {
                        key:_key,
                        value:_value,
                        level:_level,
                        forward:vec![None;_level+1]
                    }
                )
            )
        }
    }
    
    
    ///## Skiplist
    /// 
    /// 
    #[derive(Debug)]
    pub struct Skiplists<K,V>
    {
        max_level:usize,
        current_level:usize,
        current_size:usize,
        head:Vec<Option<Rc<RefCell<Node<K,V>>>>>
    }

    impl<K,V> Skiplists<K,V>
    {
        pub fn new(_max_size:usize)->Self
        {
            
            Skiplists
            {
                max_level:_max_size,
                current_level:0,
                current_size:0,
                head:vec![None;_max_size+1]

            }
        }

        fn creat_node(_key:K,_value:V,_level:usize)->Rc<RefCell<Node<K,V>>>
        {
            Node::new(_key, _value, _level)
        }

        fn insert(&mut self,_key:K,_value:V)->bool
        {
            let mut update:Vec<Option<Rc<RefCell<Node<K,V>>>>>=vec![None;self.current_level];
            let mut _node_level=random::random::lgc(self.max_level);
            let new_node: Rc<RefCell<Node<K, V>>>=Node::<K,V>::new(_key, _value, _node_level);
            if self.current_size==0
            {
                let mut begin:usize=0;
                
                while(begin<=_node_level)
                {
                    self.head[begin]=Some(new_node.clone());             //if the skiplist is empty,insert directly.
                    begin=begin+1;
                }
                
            }
            else {
                let mut tmp:usize=_node_level;                     //search the correct place up to down
                
            }
            true
        }
    }
}